*=====================================================*
*													  *
* Список изменений в утилите Custom.RUS.ProtocolTEST  *
*													  *
*=====================================================*

3.8.5.2
- В форме выполнения макроса добавлен флаг "Стоп при ошибке". 
Если флаг установлен, то при возникновении ошибки во время выполнения макроса, выполнение будет остановлено. 
Если флаг не установлен, то выполнение макроса продолжится, несмотря на возникшую ошибку."

3.8.5.0
- Добавлена информация о напряжении батареи в команде 0xF1. Кнопка "Статус ККТ" в утилите. (Для прошивок >= 5.04.04)
- Добавлена настройка печати ставок НДС за смену. Настройка "Конфигурация чека", флаг "Добавить счетчики НДС в X/Z-отчеты" (Для прошивок >= 5.04.04)

3.8.4.0
- добавлены НДС 22, 22/122 для SVELTA

3.8.3.0
- добавлен параметр загрузки логотипа в режиме командной строки
  Пример: RUSProtocolTEST.exe logo --logoname logo.bmp --logoindex 1 --con com --port COM3
  logo - команда загрузки логотипа
   --logoname - имя файла логотипа, должен находиться в папке с RUSProtocolTEST.exe
   --logoindex - индекс логотипа (1-25)
 

3.8.2.0
- исправлена ошибка при сохранении/загрузке настроек для VKP80III-ФА
- проверка наличия новой версии прошивки при подключении ККТ. 
  При наличии новой версии появится уведомление. Для получения новой прошивки обратиться в тех поддержку.

3.8.1.1
- добавлна проверка наличия новой версии прошивки ККТ

3.8.0.1
- Добавлена поддержка ставок НДС 22% и 22/122%

3.8.0.0
- добавлены новые параметры для нефискального документа (для прошивок >= 5.03.08)

3.7.2.1
- оптимизирован поиск ККТ по IP
- исправлены ошибки

3.7.1.4
- в форму макроса добавлена возможность выполнять макрос в цикле с заданным количеством повторов и паузой между повторами

3.7.1.2
- исправлены ошибки регистрации/перерегистрации с флагами "Торговый автомат" и тегами 1275/1283

3.7.1.1
- исправлена ошибка загрузки регистрационных данных из файла

3.7.1.0
- добавлены настройки для чтения/записи из командной строки: "Основные настройки", "Настройки шрифтов", "Настройки оплаты"

3.7.0.0
- добавлены параметры для запуска из командной строки. Описание см. readme.md

3.6.0.0
- добавлена настройка часовой зоны 1011

3.5.0.4
- исправлена передача тега 1011 "Часовая зона" при открытии чека

3.5.0.3
- исправлена ошибка подключения к ТК302-ФБ при регистрации в ФФД 1.05

3.5.0.2
- принудительное отключение портов при подключении к ККТ

3.5.0.1
- исправление ошибок закрытия чека в форме Доп. Реквизитов ФФД 1.2 

3.5.0.0
- добавлена поддержка тегов 1082, 1263, 1237, 1238, 1125

3.4.1.0
- исправлена ошибка при перерегистрации

3.4.0.2
- исправлена ошибка флага "Игнорировать бумагу"

3.4.0.1
- исправлена ошибка регистрации/закрытия ФН c тегами 1274, 1275, 1282, 1283

3.4.0.0
для прошивок => 5.03.08
  -- добавлен флаг "Игнорировать бумагу" в командах: Регистрация, Закрытие ФН, Отчеты (Z/X/Расчеты), Открытие чека и коррекции, Внесение, Изъятие, Копия чека, Открытие/Закрытие смены, Открытие нефискального документа, Открытие графического билета
- исправлены ошибки	

3.3.1.3
- исправлены ошибки в тегах #1227, 1086

3.3.1.2
- обновлен обработчик ошибок в консольной версии
- добавлена команда перезапуска ККТ в консольной версии, только с опцией --port 

Параметры запуска из командной строки:
  RUSProtocolTEST [commands] [options]

Commands:
  list 						получить список ККТ
  settings read				считать настройки ККТ
  settings write			записать настройки в ККТ
  register read				считать регистрационные данные ККТ (зарезервировано, ожидается в следующей версии)
  register write			перерегистрация ККТ (зарезервировано, ожидается в следующей версии)
  upgrade					обновление прошивки ККТ
  reboot					перезапуск ККТ

Options:
  --file <file> (REQUIRED)  	файл регистрационных данных или параметров в формате *.xml
  --firmware <file> (REQUIRED)  файл прошивки в формате *.lzb
  --con <com|eth>           	тип подключения к ККТ com или eth для обновления всех найденных ККТ
  --port <port> (REQUIRED)  	имя COM-порта или IP-адрес для чтения/записи настроек только с одной ККТ
  -?, -h, --help            	Show help and usage information


3.3.1.1
- исправлен вызов макроса

3.3.1.0
- изменены параметры запуска из командной строки
- добавлена команда чтения/записи настроек ККТ


Параметры запуска из командной строки:
  RUSProtocolTEST [commands] [options]

Commands:
  list 						получить список ККТ
  settings read				считать настройки ККТ
  settings write			записать настройки в ККТ
  register read				считать регистрационные данные ККТ (зарезервировано, ожидается в следующей версии)
  register write			перерегистрация ККТ (зарезервировано, ожидается в следующей версии)
  upgrade					обновление прошивки ККТ

Options:
  --file <file> (REQUIRED)  	файл регистрационных данных или параметров в формате *.xml
  --firmware <file> (REQUIRED)  файл прошивки в формате *.lzb
  --con <com|eth>           	тип подключения к ККТ com или eth для обновления всех найденных ККТ
  --port <port> (REQUIRED)  	имя COM-порта или IP-адрес для чтения/записи настроек только с одной ККТ
  -?, -h, --help            	Show help and usage information


3.2.0.3
- исправлен поиск ККТ в сети

3.2.0.0
- добавлена проверка состояния смены при обновлении из командной строки

3.1.0.0
- добавлена возможность прошивки ККТ из командной строки
Параметры:
--fw <firmware.lzb>  параметр для обновления прошивки, q3xru.lzb - файл прошивки, должен находиться в папке с RUSProtocolTEST.exe
--list  отображает подключенные ККТ по заданному интерфейсу 
--con <com/eth>  интерфейс подключения ККТ, com - COM-порт, eth - Ethernet (**Обязательный параметр)

Обновляются все ККТ подключенные к ПК по COM-порту, перед обновлением проверяется версия прошивки и модель ККТ.
Поддерживается перепрошивка ККТ Q3X-Ф и VKP80III-ФА

примеры:
RUSProtocolTEST.exe --fw q3xru.lzb --con com
обновляет все ККТ Q3X-Ф, подключенные по COM

RUSProtocolTEST.exe --list --con eth
отображает список всех ККТ подключенных к сети, и находящихся в одной подсети с ПК


2.17.1.0
- исправлена ошибка при формировании образа прошивки (Сервис -> Скачать образ прошивки)
*=====================================================*
2.17.0.0
- TK302-ФБ - добавлены налоговые ставки 5, 7, 5/105, 7/107

2.16.0.0
- Q3X-Ф/VKP80III-ФА - добавлены налоговые ставки 5, 7, 5/105, 7/107

2.15.2.1
- добвалены настройки:
  - отключение печати тега 1084 (дополнительный реквизит пользователя) - Параметры чека (только для прошивок >= 5.02.38)
  - группировка одинаковых позиций при продаже по GTIN - Конфигурация чека (только для прошивок >= 5.02.38)
- для прошивок => 5.02.38 добавлена возможность указывать количество с точностью до 6 знаков после запятой

2.15.1.3
- исправлены ошибки при подключении к ТК302-ФБ

2.15.1.2
Изменения для прошивок ККТ >= 5.02.30
- добавлена регистрация с признаками применения ККТ: "ККТ С ТОРГ. АВТОМАТОМ", "ККТ В ОБЩ. ПИТАНИИ", "ККТ В ОПТ. ТОРГОВЛЕ С ОРГ. И ИП". Необходим ФН с поддержкой данных признаков.
- добавлена возможность работы с кодами GTIN (пиво и слабоалкогольные напитки).
- добавлен флаг сохранения STLV в файл.

2.15.0.4
- вывод ошибок при загрузке логотипов

2.15.0.3
- исправление ошибок при выполнении макроса

2.15.0.2
- в команде закрытия чека (85h) добавлен флаг возврата данных фискального QR-кода (только для прошивок >= 5.02.28)
- перевод нестроек в USB-профиле ККТ
- исправление ошибок

2.14.0.0
- добавлена проверка наличия новой версии утилиты на сайте
- исправление ошибок

2.13.2.10
- исправлена ошибка подключения по IP-адресу при ручном вводе адреса

2.13.2.9
- исправлен поиск ККТ по IP
- добавлена возможность сохранения данных на вкладке "Статус ФН"
- исправление ошибок

2.13.2.8
- исправлено чтение документов с номером более 100000

2.13.2.7
- исправление ошибки чтения порта в настройках ОФД

2.13.2.6
- добавлен сетевой поиск ККТ

2.13.2.5
- добавлена коррекция часов реального времени
- добавлена настройка имени ККТ для сетевого поиска
- исправление ошибок

2.13.2.4
- исправление ошибок
- добавлены всплывающие подсказки с названием функции (команды) к некоторым операциям

2.13.2.3
- исправлены ошибки в запросе "Статус ОФД"
- файлы перевода перенесены в папку Localizations

2.13.2.1
- настройки порогового значения в минутах для проверки разницы времени ПК / ККТ

2.13.2.0
- добавлены настройки чека:
  - печать ЗН ККТ 
  - отключение печати названия валюты 'РУБ'
- добавлено состояние денежного ящика
- добавлена проверка Даты/Времени ККТ при подключении
- исправлены ошибки

2.13.1.9
- Добавленва отправка на сервер мониторинга по открытию смены

2.13.1.8
- испарвлена ошибка сохранения настроек сервера мониторинга
- добавлена команда 93h - Проверка Кода Маркировки / Кода Товара

2.13.1.6
- исправлены настройки оплаты для ПО >= 5.02.00

2.13.1.3
- исправлено отображение итогов для пользовательских платежей 6 и 7

2.13.1.1
- добавлены пользовательские типы оплат

2.13.0.64
- исправлены ошибки настройки денежного ящика для VKP (семейство параметров 019)

2.13.0.61
- добавлены настройки эджектора (Таблица параметров 673) и настройки шрифтов (семейство параметров 672)

2.13.0.60
- добавлена отправка #1162 Код Товара

2.13.0.59
- добавлено отключение проверки КМ в ОИСМ

2.13.0.58
- исправлен разбор кода GS1 (#1304)

2.13.0.57
- исправлена ошибка при работе с прошивкой 4.10.ХХ

2.13.0.56
- добавлена возможность проверки КМ без открытия чека в форме ввода КМ

2.13.0.55
- обоновлена форма ввода КМ

2.13.0.54
- добавлена печать логотипа в нефискальном чеке

2.13.0.53
- переход на API 5

2.13.0.52
- исправления в парсере Кодов Маркировки

2.13.0.50
- иcправлено название файла выгрузки уведомлений

2.13.0.49
- обновлена выгрузка уведомлений для автономного режима. файл формируется в бинарном формате .crpt

2.13.0.48
- добавлена проверка доступности серверов: ОФД, ОИСМ, АС ОКП
- добавлена выгрузка уведомлений для автономного режима

2.13.0.47
- обновлена отправка тегов 1256

2.13.0.45
- обновлена отправка тегов 1256.
- добавлена отправка КМ в ККТ без проверки. Проверку проводит ККТ.
- поддержка 30 кассиров.
- [VKP80] обновлена загрузка параметров ОФД.

2.13.0.43
- исправлены значения реквизита «признак предмета расчета» (тег 1212) 

2.13.0.41
- исправлена ошибка отправки тега #1227
- исправлена ошибка подключения после сброса COM-порта

2.13.0.40
- исправлены ошибки
- добавлено отображение секунд при запросе даты/времени (для ПО ККТ >= 05.02.00)

2.13.0.34
- исправлена ошибка доступа к настройкам ОФД, при отключенной ККТ
- обновлен перевод параметров ОФД/ОИСМ/АС ОКП

2.13.0.33
- исправлена информация о ККТ, если ККТ не зарегистрирована
- флаги "Соханить в Файл" включена по умолчанию для чеков, смены, регистрации
- обновлен перевод

2.13.0.32
- исправлена ошибка выбора типа мерного товара, при открытии Формы маркированного товара

2.13.0.31
- исправлена ошибка при работе с КМ

2.13.0.30
- расчет смещения полей 91 и 92 для Кода Маркировки
- незначительные изменения в интерфейсе (обновление статуса смены и ККТ, в том числе после регистрации)
- исправление ошибок

2.13.0.28
- исправлена ошибка сохранения параметров ОФД/ОИСМ

2.13.0.27
- исправления:
 - обновление информации о ККТ после Регистрации/Перерегистрации
 - при выборе ФФД 1.2 флаги Агентов недоступны для изменения, их значения игнорируются
 - незначительные исправления в интерфейсе
 - обновление перевода
 
2.13.0.25
- исправление ошибок подключения к ККТ

2.13.0.23
- исправления:
 - поля доп данных ОЗ/ОР/ОС/Рег измененены: было текстовое поле, стало поле данных HEX
 - обновлены значения тега 1212, добавлены значения 27,30-33

2.13.0.19
- обновлен алгоритм распознавания кода маркировки
- исправлена загрузка данных о регистрации из xml

2.13.0.17
- добавлена поддержка ФФД 1.2

2.13.0.11
- добавлены настройки типов оплаты

2.13.0.10
Обновление интерфейса:
1) Изменена структура вкладок. Кнопки постарались распределить по назначению;
 а) запросы статуса ККТ на вкладке "Статус";
 б) настройки ККТ на вкладке "Настройки ККТ";
 в) открытие/закытие Смены - вкладка "Смена";
 г) Сервисные функции: тех сброс, обновление прошивки и т.д. - вкладка "Сервис";
 д) все что отностится к чеку - вкладка "Чеки". в ней дополнительные вертикальные вкладки;
2) Лог теперь хранится в папке Log утилиты;
3) Можно сохранять/загружать регистрационные данные ККТ в/из файла, при этом ФФД, тип и причину регистрации все равно выбирать вручную!
4) Запросы статусов ККТ и ФН дополнительно выводятся в окно информации в читаемом виде;
5) НДС (Отделы), добавлено отображение ставки НДС в читаемом виде, номер отдела остался в скобах;
- добавлена поддержка ККТ версии 04.09.00 

2.12.0.0
- переход на новый API 3.8.0.0

2.11.1.5
- добавлен новый параметр в настройки сервера мониторинга: Отправка данных при закрытии ФН

2.11.1.4
- Исправлены ошибки в настройках параметров Эджектора для VKP80III-Ф

2.11.1.3
- Добавлена поддержка VKP80III-Ф

2.11.1.2
- исправлены ошибки
- сервисные настройки перенесены на отдельную закладку
- расширено отображение статуса ККТ (смена, прошивка, ЗН, РНМ и т.д)

2.11.1.1
- обновлен API до версии 3.7.0.5

2.11.1.0
- добавлены настройки сервера мониторинга

2.7.0.6
- для макроса добавлена пауза. для вставки паузы X-секунд макросе добавить строку: #DELAY(X)

2.7.0.5
[рекомендовано для прошивок 04.04.00 и выше]
- добавлена глобальная настройка печати НДС в параметрах чека. Если включена - НДС печатается всегда, если выключена - НДС печатается в зависимости от флага переданного в командах "Продажа" / "Закрытие чека"

2.7.0.3
- исправление ошибок при работе с прошивками < 4.04.00

2.7.0.0
- возможность не печатать ставку НДС в предмете расчета
- возможность не печатать ставки НДС в Итогах
- передача кода маркировки (два новых пункта «Данные со сканера», «Данные для ОФД»)
- новые признаки предмета расчета («Расход», Различные страховые взносы и т.д.)
- изменение номера Автомата (#1036) при закрытии чека

2.6.1.0
- добавлено окно лога при работе с макросом
- добавлены настройки шрифта предмета продажи (для прошивок > 4.04.00)
- добавлены новые параметры в команде запроса статуса: кол-во отрезов, кол-во включений, кол-во отпечатанной бумаги (для прошивок > 4.04.00)

2.6.0.0
- добавлено изменение адреса и места расчета (#1009/1187) при закрытии чека

2.5.0.1
- исправление ошибок
- обновление перевода

2.5.0.0
- добавлена настройка таймаутов ОФД

2.4.1.0
- добавлена поддержка кодов товара: сигареты, меха, лекарства, обувь

2.4.0.7
- исправление ошибок при печати скидки на позицию

2.4.0.6
- [Q3X-Ф] исправление ошибок при обновлении прошивки через утилиту. Увеличена скорость загрузки прошивки.
- добавлена команда запроса статуса смены

2.4.0.3[4/5]
- исправление ошибок

2.4.0.2
- скрытие неиспользуемых вкладок при подключении ККТ в зависимости от модели
- добавлена возможность подключения к ККТ по сети Ethernet
- добавлена возможность отправки макросов .rx2, и команд в ручном режиме 
- [Q3X-Ф] добавлена печать графического билета
- исправлены ошибки

2.4.0.1
- [Q3X-Ф] добавлена печать штрих-кодов в нефискальном режиме

2.4.0.0
- добавлены вкладки для работы с файлами и прошивкой

2.3.0.7
- добавлен выбор размера шрифта при печати текста нефискального документа
- исправлена ошибка подключения к COM-порту 

2.3.0.6
- добавлено описание COM-порта в выпадающем списке

2.3.0.5
- [Q3X-Ф] добавлена настройка шрифта в теле чека (бит 16...19)
- [Q3X-Ф] добалена настройка размера шрифта заголовков и сообщения в конце чека (семейство параметров 921/931)
- [TK] перевод параметров SVELTA
- добавлена возможность обновить список COM-портов
- информация о версии ПО и о подключенной ККТ

*=========================*
*						  *
*  Список изменений API   *
*						  *
*=========================*

5.02.21.04
- new Family Codes: 089 - RTC Correction, 939 - Ethernet Locator Name

3.8.0.0 : 2020.10.16
- changed library for Serial Port. Old variant MS System.IO, new SerialPortStream.

3.7.0.8 : 2020.10.02
- added new monitoring parameter (FM Close Event) in P036 Family: Remote Server Access

3.7.0.6 : 2020.09.21
- added VKP80III-F Family P671 - Ejector Configuration

3.7.0.5 : 2020.08.18
- added COM/IP information to log
- fixed launch of multiple instances of API for external connections

3.7.0.4 : 2020.08.10
- added new P036 Family for Monitoring Server

3.7.0.3 : 2020.07.24
- updated marking format
- update commands for fiscal doc
 -- new sale command: PrintRecItem with bool "operationBetweenOrganizations"
 -- new check closing command: CheckClosing with address of Payment and place of Payment
- API log settings in app.config
- added error description file

3.6.1.0 : 2020.04.30 
- new marking format
- bug fix

3.6.0.0 - initial commit